

#include "Chaining.h"

namespace armarx::skills::provider
{

    ChainingSkill::ChainingSkill() : SimpleSkill(GetSkillDescription())
    {
    }

    SkillDescription
    ChainingSkill::GetSkillDescription()
    {
        return SkillDescription{.skillId = armarx::skills::SkillID{.skillName = "ChainingSkill"},
                                .description =
                                    "This skill calls the Timeout skill three times. The last "
                                    "execution is aborted due to a timeout of this skill.",
                                .timeout = armarx::core::time::Duration::MilliSeconds(5000)};
    }

    Skill::MainResult
    ChainingSkill::main(const MainInput& in)
    {
        SkillProxy prx(
            manager,
            skills::SkillID{.providerId = *getSkillId().providerId, .skillName = "Timeout"});

        ARMARX_INFO << "CALL PROXY FIRST TIME";
        callSubskill(prx);
        ARMARX_INFO << "CALL PROXY SECOND TIME";
        callSubskill(prx);
        ARMARX_INFO << "CALL PROXY THIRD TIME";
        callSubskill(prx);

        this->throwIfSkillShouldTerminate();

        return {TerminatedSkillStatus::Succeeded, nullptr};
    }
} // namespace armarx::skills::provider
