#pragma once

#include <RobotAPI/libraries/PriorKnowledge/core/PKFinder.h>

namespace armarx::priorknowledge::robots
{
    class RobotFinder : public core::PKFinder
    {

    public:
        using core::PKFinder::PKFinder;
        static const constexpr auto DEFAULT_DIR_TO_IDS = "robots";

        RobotFinder(const std::filesystem::path& relDir = DEFAULT_DIR_TO_IDS) :
            core::PKFinder(relDir)
        {
        }

        bool
        accept(const std::filesystem::path& idPath) const final
        {
            return std::filesystem::is_directory(idPath);
        }

        void
        registerPropertyDefinitions(armarx::PropertyDefinitionsPtr& defs,
                                    const std::string& prefix = "pk.finder.robots.") final
        {
            core::PKFinder::registerPropertyDefinitions(defs, prefix);
        }
    };

} // namespace armarx::priorknowledge::robots
