#pragma once

#include <filesystem>

// Base Class
#include "detail/EntityInstanceBase.h"
#include "detail/mixins/DiskStorageMixin.h"
#include "detail/mixins/MongoDBStorageMixin.h"

namespace armarx::armem::server::ltm
{

    class EntityInstance :
        public detail::EntityInstanceBase,
        public detail::mixin::DiskMemoryItemMixin,
        public detail::mixin::MongoDBStorageMixin
    {
    public:
        EntityInstance(const detail::mixin::Path&,
                       const detail::mixin::MongoDBSettings&,
                       const std::string&,
                       const MemoryID& id,
                       const std::shared_ptr<Processors>& p);

    protected:
        void _loadAllReferences(armem::wm::EntitySnapshot&) const override;
        void _resolve(armem::wm::EntityInstance&) const override;
        nlohmann::json _store(const armem::wm::EntityInstance&) override;

    private:
    };

} // namespace armarx::armem::server::ltm
