#pragma once

// Base Class
#include <RobotAPI/libraries/aron/core/data/visitor/variant/VariantVisitor.h>

#include "../Extractor.h"

namespace armarx::armem::server::ltm::processor::extractor
{
    class DepthImageExtractorVisitor : public aron::data::RecursiveVariantVisitor
    {
    public:
        std::map<std::string, aron::data::VariantPtr> depthImages;

        void visitDictOnEnter(Input& data);
        void visitUnknown(Input& data);
    };

    class DepthImageExtractor : public Extractor
    {
    public:
        DepthImageExtractor() : Extractor(aron::type::Descriptor::IMAGE, "depthimage"){};

        ExtractionResult extract(aron::data::DictPtr& data) override;
        aron::data::DictPtr merge(ExtractionResult& encoding) override;
    };
} // namespace armarx::armem::server::ltm::processor::extractor
