/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Andre Meixner ( andre dot meixner at kit dot edu )
 * @date       2023
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <RobotAPI/libraries/armem_robot_state/server/forward_declarations.h>

namespace armarx::armem::server::robot_state::proprioception
{

struct JointValues
{
    double position = 0.0;
    double velocity = 0.0;
    double torque = 0.0;
    //double torqueTicks = 0.0;
};

struct ForceTorqueValues
{
    Eigen::Vector3f force = Eigen::Vector3f::Zero();
    Eigen::Vector3f torque = Eigen::Vector3f::Zero();
};

struct SensorValues
{
    JointValuesMap jointValueMap;
    ForceTorqueValuesMap forceTorqueValuesMap;
};

}

