#include "SkillExecutionRequest.h"

namespace armarx
{
    namespace skills
    {
        manager::dto::SkillExecutionRequest
        SkillExecutionRequest::toManagerIce() const
        {
            manager::dto::SkillExecutionRequest ret;
            ret.skillId = skillId.toManagerIce();
            ret.executorName = executorName;
            ret.parameters = armarx::aron::data::Dict::ToAronDictDTO(parameters);
            return ret;
        }

        provider::dto::SkillExecutionRequest
        SkillExecutionRequest::toProviderIce() const
        {
            provider::dto::SkillExecutionRequest ret;
            ret.skillId = skillId.toProviderIce();
            ret.executorName = executorName;
            ret.parameters = armarx::aron::data::Dict::ToAronDictDTO(parameters);
            ret.callbackInterface = callbackInterface;
            return ret;
        }

        SkillExecutionRequest
        SkillExecutionRequest::FromIce(const manager::dto::SkillExecutionRequest& req)
        {
            return {skills::SkillID::FromIce(req.skillId),
                    req.executorName,
                    armarx::aron::data::Dict::FromAronDictDTO(req.parameters),
                    nullptr};
        }

        SkillExecutionRequest
        SkillExecutionRequest::FromIce(const provider::dto::SkillExecutionRequest& req,
                                       const std::optional<skills::ProviderID>& providerId)
        {
            return {skills::SkillID::FromIce(req.skillId, providerId),
                    req.executorName,
                    armarx::aron::data::Dict::FromAronDictDTO(req.parameters),
                    req.callbackInterface};
        }

    } // namespace skills
} // namespace armarx
